SortedSetMultimap
Date: 2016-05-24

com.google.common.collect

## Interface SortedSetMultimap<K,V>

- All Superinterfaces:
    Multimap<K,V>, SetMultimap<K,V>
  All Known Implementing Classes:
    ForwardingSortedSetMultimap, TreeMultimap

      @GwtCompatible
      public interface SortedSetMultimap<K,V>
      extends SetMultimap<K,V>

  A `SetMultimap` whose set of values for a given key are kept sorted; that is, they comprise a `SortedSet`. It cannot hold duplicate key-value pairs; adding a key-value pair that's already in the multimap has no effect. This interface does not specify the ordering of the multimap's keys. See the `Multimap` documentation for information common to all multimaps.

  The `get(K)`, `removeAll(java.lang.Object)`, and `replaceValues(K, java.lang.Iterable<? extends V>)` methods each return a `SortedSet` of values, while `Multimap.entries()` returns a `Set` of map entries. Though the method signature doesn't say so explicitly, the map returned by `asMap()` has `SortedSet` values.

  See the Guava User Guide article on `Multimap`.

  Since:
    2.0

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Map<K,java.util.Collection<V>>` | `asMap()` Returns a map view that associates each key with the corresponding values in the multimap.
    `java.util.SortedSet<V>` | `get(K key)` Returns a collection view of all values associated with a key.
    `java.util.SortedSet<V>` | `removeAll(java.lang.Object key)` Removes all values associated with a given key.
    `java.util.SortedSet<V>` | `replaceValues(K key, java.lang.Iterable<? extends V> values)` Stores a collection of values with the same key, replacing any existing values for that key.
    `java.util.Comparator<? super V>` | `valueComparator()` Returns the comparator that orders the multimap values, with `null` indicating that natural ordering is used.

    - ### Methods inherited from interface com.google.common.collect.SetMultimap

      `entries, equals`

    - ### Methods inherited from interface com.google.common.collect.Multimap

      `clear, containsEntry, containsKey, containsValue, hashCode, isEmpty, keys, keySet, put, putAll, putAll, remove, size, values`

- - ### Method Detail

    - #### get

          java.util.SortedSet<V> get(@Nullable
                                   K key)

      Returns a collection view of all values associated with a key. If no mappings in the multimap have the provided key, an empty collection is returned.

      Changes to the returned collection will update the underlying multimap, and vice versa.

      Because a `SortedSetMultimap` has unique sorted values for a given key, this method returns a `SortedSet`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `get` in interface `Multimap<K,V>`
      Specified by:
        `get` in interface `SetMultimap<K,V>`

    - #### removeAll

          java.util.SortedSet<V> removeAll(@Nullable
                                         java.lang.Object key)

      Removes all values associated with a given key.

      Because a `SortedSetMultimap` has unique sorted values for a given key, this method returns a `SortedSet`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `removeAll` in interface `Multimap<K,V>`
      Specified by:
        `removeAll` in interface `SetMultimap<K,V>`
      Returns:
        the values that were removed (possibly empty). The returned collection may be modifiable, but updating it will have no effect on the multimap.

    - #### replaceValues

          java.util.SortedSet<V> replaceValues(K key,
                                             java.lang.Iterable<? extends V> values)

      Stores a collection of values with the same key, replacing any existing values for that key.

      Because a `SortedSetMultimap` has unique sorted values for a given key, this method returns a `SortedSet`, instead of the `Collection` specified in the `Multimap` interface.

      Any duplicates in `values` will be stored in the multimap once.

      Specified by:
        `replaceValues` in interface `Multimap<K,V>`
      Specified by:
        `replaceValues` in interface `SetMultimap<K,V>`
      Returns:
        the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.

    - #### asMap

          java.util.Map<K,java.util.Collection<V>> asMap()

      Returns a map view that associates each key with the corresponding values in the multimap. Changes to the returned map, such as element removal, will update the underlying multimap. The map does not support `setValue()` on its entries, `put`, or `putAll`.

      When passed a key that is present in the map, `asMap().get(Object)` has the same behavior as `get(K)`, returning a live collection. When passed a key that is not present, however, `asMap().get(Object)` returns `null` instead of an empty collection.

      Note: The returned map's values are guaranteed to be of type `SortedSet`. To obtain this map with the more specific generic type `Map<K, SortedSet<V>>`, call `Multimaps.asMap(SortedSetMultimap)` instead.

      Specified by:
        `asMap` in interface `Multimap<K,V>`
      Specified by:
        `asMap` in interface `SetMultimap<K,V>`

    - #### valueComparator

          java.util.Comparator<? super V> valueComparator()

      Returns the comparator that orders the multimap values, with `null` indicating that natural ordering is used.